/**
 * about:bookmarkshome handler
 * (c) 2005 Myen adapted by Jeroen Groenenboom and jean-bernard marcon
 * based on kitchensink, Mozilla's nsAboutRedirector.cpp and related files
 * License: MPL
 */

function aboutBookmarkshome(){}

aboutBookmarkshome.prototype = {
	
	get K_URI() { return "chrome://bookmarkshome/locale/bookmarksHome.html"; },

/* nsIAboutModule */
	/* nsIChannel newChannel(in nsIURI aURI); */
	newChannel: function ( aURI ) {
		var ex;
		// sanity check
		aURI = aURI.QueryInterface( Components.interfaces['nsIURI'] );
		
		var ioService = 
			Components.classes['@mozilla.org/network/io-service;1']
			          .getService( Components.interfaces['nsIIOService'] );
		var tempChannel =
			ioService.newChannel( this.K_URI, null, null );
		
		try {
			tempChannel.setOriginalURI(aURI);
		} catch ( ex ) {
			// exception ignored
		}
		
		// XXX Mook: I have tested this, and the resulting channel does not appear
		// to have chrome privileges.  
		
		return tempChannel;
	},

/* nsISupports */
	QueryInterface: function (aIID) {
		var interfaces = [
			'nsISupports',
			'nsIAboutModule'
			];
		for( var index in interfaces ) {
			if ( aIID.equals( Components.interfaces[interfaces[index]] ))
				return this;
		}
		throw this.C_RESULTS['NS_ERROR_NO_INTERFACE'];
    }
}
